Radio={}

function initArray2(f,v)
    local cmd = {}
    for c = 1, f do
    	cmd[c] = v
    end
    return cmd
end

function initArray3(f,x,v)
    local cmd = {}
    for c = 1, f do
    	cmd[c] = {x,v}
    end
    return cmd
end

Radio.Frequency=initArray2(32,0)
Radio.IsChangingFq=initArray2(32,false)
Radio.IsBroadcasting=initArray2(32,false)
Radio.IsZeroBlocked=initArray2(32,false)

-- Frequency 0 is general (everyone hears you),
-- Frequencies 1-100 - specific,
-- Frequencies 101-132 - heard only to ID of the player (e.g. 112 is only heard to player with ID 12).

function Radio.Menu(id)
    if (Radio.IsBroadcasting[id]==false) then
        if not (Radio.IsZeroBlocked[id]) then
            menu(id,"Radio Menu,Change Frequency,Broadcast,Block Frequency 0")
        else
            menu(id,"Radio Menu,Change Frequency,Broadcast,Unblock Frequency 0")
        end
    else
        menu(id,"Radio Menu,,End Broadcast")
    end
end

addhook("serveraction","Radio.Serveraction")
function Radio.Serveraction(id,a)
    if (a==3) then
        Radio.Menu(id)
    end
end

addhook("menu","Radio.Menusel")
function Radio.Menusel(id,menu,sel)
    if (menu=="Radio Menu") then
        if (sel==1) then
            Radio.IsChangingFq[id]=true
            msg2(id,"Enter the needed frequency (0-132) in chat.")
        end
        if (sel==2) then
            if (Radio.IsBroadcasting[id]==false) then
                Radio.IsBroadcasting[id]=true
                msg2(id,"You are now broadcasting.")
            else
                Radio.IsBroadcasting[id]=false
                msg2(id,"You are not broadcasting anymore.")
            end
        end
        if (sel==3) then
            if not (Radio.IsZeroBlocked[id]) then
                Radio.IsZeroBlocked[id]=true
                msg2(id,"You now ignore frequency 0.")
            else
                Radio.IsZeroBlocked[id]=false
                msg2(id,"You don't ignore frequency 0 anymore.")
            end
        end
    end
end

addhook("say","Radio.Say")
function Radio.Say(id,t)
    if (Radio.IsBroadcasting[id]) then
        if (Radio.Frequency[id]==0) then
            for pl=1,32 do
                if (player(pl,"exists") and Radio.IsZeroBlocked[pl]==false) then
                    msg2(pl,player(id,"name").." (RADIO): "..t)
                end
            end
            print(player(id,"name").." (RADIO): "..t)
            return 1
        elseif (Radio.Frequency[id]>0 and Radio.Frequency[id]<=100) then
            msg2(id,player(id,"name").." (RADIO FQ "..Radio.Frequency[id].."): "..t)
            for pl=1,32 do
                if (player(pl,"exists") and Radio.Frequency[pl]==Radio.Frequency[id] and pl~=id) then
                    msg2(pl,player(id,"name").." (RADIO FQ "..Radio.Frequency[id].."): "..t)
                end
            end
            print(player(id,"name").." (RADIO FQ "..Radio.Frequency[id].."): "..t)
            return 1
        elseif (Radio.Frequency[id]>100) then
            msg2(id,player(id,"name").." (RADIO FQ "..Radio.Frequency[id].."): "..t)
            msg2(Radio.Frequency[id]-100,player(id,"name").." (RADIO FQ "..Radio.Frequency[id].."): "..t)
            print(player(id,"name").." (RADIO FQ "..Radio.Frequency[id].."): "..t)
            return 1
        end
    end
    if (Radio.IsChangingFq[id]) then
        local fq=tonumber(t:sub(1,2))
        if (fq~=nil and fq>=0 and fq<=132) then
            Radio.Frequency[id]=tonumber(t:sub(1,3))
            msg2(id,"Your radio frequency is now "..Radio.Frequency[id])
            Radio.IsChangingFq[id]=false
            return 1
        end
    end
end